;************************************************
;*                ION83Emu v1.0                 *
;*Emulateur de la TI-83 et du shell ION pour SNG*
;*                 09/08/2004                   *
;*             par Marc Plouhinec               *
;*       site: http://www.thebestof.tk          *
;*    Email: mailto://m_plouhinec@yahoo.fr      *
;*                                              *
;************************************************

; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; as published by the Free Software Foundation; either version 2 
; of the License, or (at your option) any later version.


;Ce programme mule la TI-83 avec le shell ION
;C'est un mulateur en 2 parties, une sur le PC qui modifie les jeux pour les rendre compatible avec la TI-82
;et l'autre qui l'adapte pour SNG.
;Ce programme est la 2e partie de l'mulateur.

;Tches de l'mulateur:
;On laisse choisir le programme par l'utilisateur.
;on lance le programme  l'adresse DEBUT_PROG = 9327h
;On crer les buffers manquants et la table des sauts.

#include "sng10.inc"
DEBUT_PROG         = $9327-2
DEBUT_PROG_1       = $93
DEBUT_PROG_2       = $27-2
TableRomEMU        = $8F71
EMUBUFFER6         = $8F6F
NB_ROM_CALL        = 61
_getcsc		   = TableRomEMU+36
_insertmem	   = TableRomEMU+63
_deletemem	   = TableRomEMU+78
_vputs             = TableRomEMU+117
NB_2_STRING_IONEMU = TableRomEMU+168
DEL_TMP_IONEMU     = TableRomEMU+171
CREATE_TMP_IONEMU  = TableRomEMU+174
LanceRoutinesRom   = TableRomEMU+177


 .ORG START_ADDR
Commentaire .DB "ION83Emu par Marc Plouhinec",0


 LD A,0
RelanceAutomatique = $-1
 OR A
 JR Z,Debut
 XOR A
 LD (RelanceAutomatique),A
 JP RemtRomCallCommeAvant
Debut:
 LD A,1
 LD (RelanceAutomatique),A

;--------------------------------------
;1-On crer une liste de programmes
;  compatibles avec ION
;--------------------------------------

 CALL ChercheProgTEXT_MEM ;Place dans TEXT_MEM les adresses dans la VAT des programmes compatibles
 LD A,(NombreDeProgrammes)
 OR A
 RET Z
 CALL AfficheListe
 XOR A
 LD (ProgrammeSelectionne),A
 CALL AfficheUnrectangleSurLeAemeProg
 CALL GRB_COPY

Touches:
 ROM_CALL(GET_KEY)
 cp G_CLEAR
 JR Z,quit
 cp G_UP
 CALL Z,Haut
 cp G_DOWN
 CALL Z,Bas
 cp G_ENTER
 JR Z,Entree
 halt
 jr Touches

quit:
 XOR A
 LD (RelanceAutomatique),A
 RET

Haut:
 LD A,(ProgrammeSelectionne)
 OR A
 RET Z
 CALL AfficheUnrectangleSurLeAemeProg
 LD A,(ProgrammeSelectionne)
 DEC A
 LD (ProgrammeSelectionne),A
 CALL AfficheUnrectangleSurLeAemeProg
 CALL GRB_COPY
 RET

Bas:
 LD A,(NombreDeProgrammes)
 LD B,A
 LD A,(ProgrammeSelectionne)
 DEC B
 CP B
 RET Z
 CALL AfficheUnrectangleSurLeAemeProg
 LD A,(ProgrammeSelectionne)
 INC A
 LD (ProgrammeSelectionne),A
 CALL AfficheUnrectangleSurLeAemeProg
 CALL GRB_COPY
 RET

Entree:
 LD A,(ProgrammeSelectionne)
 LD H,0
 LD L,A
 ADD HL,HL
 LD BC,TEXT_MEM
 ADD HL,BC
 CALL LD_HL_MHL
 INC HL
 LD (AdresseProgALancer),HL ;HL->06
 JP LanceProg


ChercheProgTEXT_MEM:
 LD HL,TEXT_MEM
 LD DE,TEXT_MEM+1
 LD (HL),0
 LD BC,127
 LDIR
 XOR A
 LD (NombreDeProgrammes),A
 LD HL,TEXT_MEM
 LD (ListeIndex),HL
 LD HL,VAT_START
 PUSH HL
ChercheProg:
 POP HL
 LD A,6
 LD BC,$ffff
 CPDR
 LD DE,(VAT_END)
 CALL CP_HL_DE
 RET C
OnAPasFini:
 DEC HL
 PUSH HL
 LD (AdresseProgVAT),HL
 LD D,(HL)
 INC HL
 LD E,(HL)
 EX DE,HL
 INC HL
 INC HL
 LD A,(HL)
 CP $C9
 JR NZ,ChercheProgAutreType
 INC HL
 LD A,(HL)
 CP $30
 JR NZ,ChercheProg
ProgTrouve:
 POP HL
 PUSH HL
 LD HL,(ListeIndex)
 LD (HL),E
 INC HL
 LD (HL),D
 INC HL
 LD (ListeIndex),HL
 LD A,(NombreDeProgrammes)
 INC A
 CP 11
 JR Z,TropDeProgrammes
 LD (NombreDeProgrammes),A
 JR ChercheProg
TropDeProgrammes:
 POP HL
 RET

ChercheProgAutreType:
 CP $AF
 JR NZ,ChercheProg
 INC HL
 LD A,(HL)
 CP $30
 JR NZ,ChercheProg
 JR ProgTrouve

AfficheListe:
 SET 7,(IY+$14) ;Ecrit du texte de menu seulement dans la mmoire graphique (GRAPH_MEM) et pas sur l'cran LCD 
 LD HL,0
 LD (GRAF_CURS),HL
 LD HL,TEXT_MEM
 LD (ListeIndex),HL
AfficheNom:
 LD HL,(ListeIndex)
 CALL LD_HL_MHL
 LD E,(HL)
 DEC HL
 LD D,(HL)
 EX DE,HL
 LD BC,5
 ADD HL,BC
 ROM_CALL(D_ZM_STR)
 LD HL,(GRAF_CURS)
 LD L,0
 LD A,H
 ADD A,6
 LD H,A
 LD (GRAF_CURS),HL
 LD HL,(ListeIndex)
 INC HL
 INC HL
 LD (ListeIndex),HL
 XOR A
 CP (HL)
 RET Z
 INC HL
 CP (HL)
 RET Z
 JR AfficheNom

AfficheUnrectangleSurLeAemeProg:
 LD HL,6*12
 LD C,A
 LD B,0
 CALL MUL_HL_BC
 LD BC,GRAPH_MEM
 ADD HL,BC
 LD B,6*12
AfficheRectangle:
 LD A,(HL)
 XOR $FF
 LD (HL),A
 INC HL
 DJNZ AfficheRectangle
 RET


ListeIndex .DW 0
NombreDeProgrammes .DB 0
ProgrammeSelectionne .DB 0


;--------------------------------------
;2-On adapte les rom_calls
;--------------------------------------
LanceProg:
 CALL AdapteROMCALL

;--------------------------------------
;3-On remplace SNG par IONEMU
;--------------------------------------
 LD HL,PetitCode
 LD DE,TEXT_MEM
 LD BC,TaillePetitCode
 JP EXT_INSTR


AdapteROMCALL:
 LD A,($29D0)  ;pour rom |16.0:36| |17.0:37| |18.0:38| |19.0:6D| |19.006:18|
 CP $18
 JR Z,rom_19006
 CP $6D
 JR Z,rom_190
 RET

rom_190:
 LD B,NB_ROM_CALL+1
 LD HL,IONEMUROMJUMP
 PUSH HL
ModifieAdresse190:
 POP HL
 DEC B
 XOR A ;
 CP B  ;On regarde si on a fini
 RET Z ;
 INC HL
 LD E,(HL)
 INC HL
 LD D,(HL)
 INC HL
 PUSH HL
 EX DE,HL
 LD DE,$4000   ;On regarde si c'est un saut vers la rom
 CALL CP_HL_DE
 JR NC,ModifieAdresse190
 LD DE,$0A00   ;On regarde si la rom n'a pas change jusqu'ici
 CALL CP_HL_DE
 JR C,ModifieAdresse190
;ici on est sr que la rom  change, on lui ajoute $1A
 LD DE,$1A
AdditionneOuSoustrait190:
 ADD HL,DE
 NOP
 EX DE,HL
 POP HL
 PUSH HL
 DEC HL
 LD (HL),D
 DEC HL
 LD (HL),E
 JR ModifieAdresse190


rom_19006:
 LD HL,TableRom19006
 LD (AdapteTableRom19006),HL
 LD B,NB_ROM_CALL-7
 LD DE,IONEMUROMJUMP + 24
ModifieAdresse19006:
 DEC B
 XOR A ;
 CP B  ;On regarde si on a fini
 RET Z ;
 INC DE
 LD HL,0
AdapteTableRom19006 = $-2
 LD C,(HL)
 LD A,(DE)
 LD (HL),A
 LD A,C
 LD (DE),A
 INC HL
 INC DE
 LD C,(HL)
 LD A,(DE)
 LD (HL),A
 LD A,C
 LD (DE),A
 INC HL
 INC DE
 LD (AdapteTableRom19006),HL
 JR ModifieAdresse19006

TableRom19006:

.DW LD_HL_MHL      ;_ldhlind
.DW CP_HL_DE       ;_cphlde
.DW UNPACK_HL      ;_divhlby10
.DW DIV_HL_A       ;_divhlbya
.DW GET_KEY    +$1F;_getcsc
.DW $07F3      +$47;_lcdbusy
.DW $1901-$1A +$145;_hltimes9
.DW $0020          ;_mov9toop1
.DW $1B16     +$145;_zeroop1
.DW $1F18-$1A +$145;_htimesl
.DW MEM_FREE  +$145;_memfree
.DW FIND_VAT  +$145;_chksysvar
.DW $2143-$1A +$145;_findsym     -/!\?
.DW INSERT_MEM+$145;_insertmem
.DW $234D-$1A +$145;_createreal
.DW $23AD-$1A +$145;_creategdb
.DW CREATE_PRGM+$145;_createprog
.DW $2547     +$145;_delvar      -/!\?
.DW DEL_MEM   +$145;_deletemem
.DW TR_CHARPUT+$145;_putmap
.DW TX_CHARPUT+$163;_putc
.DW D_HL_DECI +$133;_disphl
.DW D_ZT_STR  +$133;_puts
.DW D_LT_STR  +$145;_putps
.DW NEXT_LINE +$145;_newline
.DW CLEARLCD  +$133;_clrlcdf
.DW CLEARLCD  +$133;_clrscr   ;(?) pas exactement emul
.DW CLEARLCD  +$133;_clrscrf  ;(?) pas exactement emul
.DW $38E4-$1A +$127;_cleartextshad ;(_ClrTxtShd)
.DW $391A-$1A +$133;_homeup
.DW M_CHARPUT +$139;_vputmap
.DW D_ZM_STR  +$139;_vputs
.DW $37F4-$1A +$139;_vputsn
.DW BUSY_ON   +$163;_indicatorOn
.DW BUSY_OFF  +$157;_indicatorOff
.DW $2f2e     +$15D;_getk
.DW $084A     +$12B;_FPSUB
.DW $0AD4     +$12C;_FPDIV
.DW $0925     +$12B;_FPMULT
.DW $35a0     +$145;_CONVOP1
.DW DISP_GRAPH+$133;_copygbuf
.DW KEY_HAND  +$163;_getkey
.DW $359A     +$145;_setxxxxop2
.DW _setxxop1-IONEMU+$8D26
.DW D_ZM_STR +$139
.DW _cleargbuf-IONEMU+$8D26 ;cette fonction de la rom existe mais il n'y a aucun appels vers cette fonction dans la rompage1
.DW _dispop1a-IONEMU+$8D26
.DW $19F5     +$145;_op2toop1
.DW NB_2_STRING +$15D    ;$30f6
.DW DEL_TMP +$145
.DW CREATE_TMP +$133
.DW $2E46     +$15D;LanceRoutinesRom
.DW _SFONT_LEN-IONEMU+$8D26


RemtRomCallCommeAvant:
 LD A,($29D0)  ;pour rom |16.0:36| |17.0:37| |18.0:38| |19.0:6D| |19.006:18|
 CP $18
 JR Z,remet_rom_19006
 CP $6D
 JR Z,remet_rom_190
 JP Debut

remet_rom_190:
;on remplace ADD HL,DE/NOP par SBC HL,DE
 LD HL,AdditionneOuSoustrait190
 LD (HL),$ED
 INC HL
 LD (HL),$52
 CALL rom_190
;On remet ADD HL,DE
 LD HL,AdditionneOuSoustrait190
 LD (HL),$19
 INC HL
 LD (HL),0
 JP Debut


remet_rom_19006:
 CALL rom_19006
 JP Debut







PetitCode:
;On cherche dans la ram le programme ION83EMU
 LD HL,(VAT_END)
ChercheION83EMU:
 LD BC,$ffff
 LD A,6
 CPIR
 PUSH HL
 LD BC,5
 SBC HL,BC
 LD DE,ION83EmuChaine-PetitCode+TEXT_MEM
 LD C,1
 CALL CP_STRING
 POP HL
 OR A
 JR Z,ChercheION83EMU
 DEC HL
 DEC HL
 LD E,(HL)
 DEC HL
 LD D,(HL)
 EX DE,HL
;HL->ION83EMU
 LD D,H                                      ;
 LD E,L                                      ;
 LD BC,AdresseION83EMUDansRam-Commentaire+39+2 ;LD (AdresseION83EMUDansRam),HL
 ADD HL,BC                                   ;
 LD (HL),E                                   ;
 INC HL                                      ;
 LD (HL),D                                   ;
 EX DE,HL                                    ;
 LD DE,IONEMU-Commentaire+39+2
 ADD HL,DE
;HL->IONEMU

 LD DE,$8D26
 LD BC,TailleIONEMU
EchangeDonnees:
 PUSH BC
 LD A,(DE)
 LD C,(HL)
 EX DE,HL
 LD (DE),A
 LD (HL),C
 EX DE,HL
 INC DE
 INC HL
 POP BC
 DEC BC
 XOR A
 CP B
 JR NZ,EchangeDonnees
 CP C
 JR NZ,EchangeDonnees
 JP LanceProg83-IONEMU+$8D26

ION83EmuChaine .DB "ION83EMU",0

PetitCodeFin:

TaillePetitCode = PetitCodeFin-PetitCode






















IONEMU:
;On cre les buffers manquants de la TI-82
 .DS TableRomEMU-$8D26
;On crer la table des 56 apels vers la rom
IONEMUROMJUMP:
 JP Version-IONEMU+$8D26
 JP Random-IONEMU+$8D26
 JP putSprite-IONEMU+$8D26
 JP largeSprite-IONEMU+$8D26
 JP getPixel-IONEMU+$8D26
 JP fastCopy-IONEMU+$8D26
 JP detect-IONEMU+$8D26
 JP decompress-IONEMU+$8D26
 JP LD_HL_MHL      ;_ldhlind
 JP CP_HL_DE       ;_cphlde
 JP UNPACK_HL      ;_divhlby10
 JP DIV_HL_A       ;_divhlbya
 JP GET_KEY        ;_getcsc
 JP $07F3          ;_lcdbusy
 JP $1901-$1A      ;_hltimes9
 JP $0020          ;_mov9toop1
 JP $1B16          ;_zeroop1
 JP $1F18-$1A      ;_htimesl
 JP MEM_FREE       ;_memfree
 JP FIND_VAT       ;_chksysvar
 JP $2143-$1A      ;_findsym     -/!\?
 JP INSERT_MEM     ;_insertmem
 JP $234D-$1A      ;_createreal
 JP $23AD-$1A      ;_creategdb
 JP CREATE_PRGM    ;_createprog
 JP $2547          ;_delvar      -/!\?
 JP DEL_MEM        ;_deletemem
 JP TR_CHARPUT     ;_putmap
 JP TX_CHARPUT     ;_putc
 JP D_HL_DECI      ;_disphl
 JP D_ZT_STR       ;_puts
 JP D_LT_STR       ;_putps
 JP NEXT_LINE      ;_newline
 JP CLEARLCD       ;_clrlcdf
 JP CLEARLCD       ;_clrscr   ;(?) pas exactement emul
 JP CLEARLCD       ;_clrscrf  ;(?) pas exactement emul
 JP $38E4-$1A      ;_cleartextshad ;(_ClrTxtShd)
 JP $391A-$1A      ;_homeup
 JP M_CHARPUT      ;_vputmap
 JP D_ZM_STR       ;_vputs
 JP $37F4-$1A      ;_vputsn
 JP BUSY_ON        ;_indicatorOn
 JP BUSY_OFF       ;_indicatorOff
 JP $2f2e          ;_getk
 JP $084A          ;_FPSUB
 JP $0AD4          ;_FPDIV
 JP $0925          ;_FPMULT
 JP $35a0          ;_CONVOP1
 JP DISP_GRAPH     ;_copygbuf
 JP KEY_HAND       ;_getkey
 JP $359A          ;_setxxxxop2
 JP _setxxop1-IONEMU+$8D26
 JP D_ZM_STR
 JP _cleargbuf-IONEMU+$8D26 ;cette fonction de la rom existe mais il n'y a aucun appels vers cette fonction dans la rompage1
 JP _dispop1a-IONEMU+$8D26
 JP $19F5          ;_op2toop1
 JP NB_2_STRING    ;$30f6
 JP DEL_TMP
 JP CREATE_TMP
 JP $2E46          ;LanceRoutinesRom
 JP _SFONT_LEN-IONEMU+$8D26
 RET ;Les appels non adapts sont redirigs ici, a evite des bugs

_dispop1a:
 LD A,9
 CALL NB_2_STRING_IONEMU ;place dans OP3 la chaine du nombre contenu dans OP1
 LD HL,OP3
 JP _vputs

_cleargbuf:
 CALL LanceRoutinesRom
 .DW $5AEB
 .DB 4
 RET

_SFONT_LEN:
 LD A,$89
 OUT (2),A
 LD DE,$600D
 ADD HL,DE
 LD B,(HL)
 RET

_setxxop1:
 CALL LanceRoutinesRom
 .DW $5a69
 .DB 4
 RET




#include "routines_de_ION.inc"






;On place maintenant le code qui va lancer le programme
LanceProg83:
;--------------------------------------
;4-On place le programme et on le lance
;--------------------------------------

;Quelques prparations avant de lancer
 LD HL,$FD9D
 LD (EMUBUFFER6),HL
;Aprs la VAT il y a toujours un 0 sur le ti-83
 LD HL,$8D18
 CALL LD_HL_MHL
 LD A,(HL)
 LD (RestoreApresVAT-IONEMU+$8D26),A
 XOR A
 LD (HL),A

;On place le programme  l'adresse DEBUT_PROG

 CALL DEL_TMP_IONEMU
 LD HL,(AdresseProgALancer-IONEMU+$8D26)
 DEC HL
 LD E,(HL)
 DEC HL
 LD D,(HL)
 LD (AdresseProgVAT-IONEMU+$8D26),HL
 EX DE,HL
 CALL PlaceLeProg-IONEMU+$8D26

;On saute le commentaire
 LD HL,DEBUT_PROG+3
 LD (AdresseVersProg-IONEMU+$8D26),HL
 RES 7,(IY+$14)
 CALL $0000
AdresseVersProg = $-2

;--------------------------------------
;5-On replace le programme comme avant
;--------------------------------------

 CALL RePlaceLeProg-IONEMU+$8D26

 LD HL,$8D18
 CALL LD_HL_MHL
 LD A,0
RestoreApresVAT = $-1
 LD (HL),A

;On remet SNG comme avant grace  PetitCode2
 LD HL,PetitCode2-IONEMU+$8D26
 LD DE,TEXT_MEM
 LD BC,PetitCode2Taille
 LDIR
 JP TEXT_MEM









PlaceLeProg:
;Pour dplacer le programme, on crer une zone libre juste aprs SNG et on dtruit le programme original aprs l'avoir copi.
;Pour ne pas gaspiller de la mmoire, on augmente la taille de la zone libre en mme temps qu'on rduit la taille du programme.

;initialisation
 LD (AdresseInitProg),HL
 LD C,(HL)
 INC HL
 LD B,(HL)
 INC BC
 INC BC
 LD (TailleDonnesADeplacer),BC
 LD (TailleProg),BC
 DEC HL
 LD (AdresseProgDetruit),HL
 LD HL,DEBUT_PROG
 LD (AdresseProgDeplace),HL

CreationDeZoneLibre:
;On crer une zone de mmoire  l'adresse AdresseProgDeplace de HL octets
;HL est { = 768 si TailleDonnesADeplacer>768
;         = TailleDonnesADeplacer sinon

 LD HL,(TailleDonnesADeplacer)
 LD BC,768
 SBC HL,BC
 JP P,TaillePositive-IONEMU+$8D26
 LD HL,(TailleDonnesADeplacer)
 JR TailleCalculee
TaillePositive:
 LD HL,768
TailleCalculee:
 PUSH HL
 LD DE,(TailleDonnesADeplacer)
 EX DE,HL
 SBC HL,DE
 LD (TailleDonnesADeplacer),HL
 POP HL
;On a calcul la taille de la mmoire  allouer
 PUSH HL
 LD DE,(AdresseProgDeplace)
 CALL _insertmem ;Allocates a region of memory: HL = size DE = address
;Cette routine modifie l'adresse du programme  copier, on modifie donc l'adresse AdresseProgDetruit
 POP HL
 PUSH HL
 EX DE,HL
 LD HL,(AdresseProgDetruit)
 Add HL,DE
 LD (AdresseProgDetruit),HL
;On copie maintenant les donnes vers la nouvelle adresse
 POP HL
 PUSH HL
 LD B,H
 LD C,L
 LD HL,(AdresseProgDetruit)
 LD DE,(AdresseProgDeplace)
 LDIR
 POP HL
;On detruit la zone copie du programme
 EX DE,HL
 PUSH DE
 LD HL,(AdresseProgDetruit)
 CALL _deletemem    ;Deletes a region of allocated memory: HL = address DE = size
 POP DE
;On met  jour AdresseProgDeplace
;ici DE = taille des donnes copies
 LD HL,(AdresseProgDeplace)
 ADD HL,DE
 LD (AdresseProgDeplace),HL
;On regarde s'il reste des donnes  copier
 LD HL,(TailleDonnesADeplacer)
 LD A,H
 CP $FF
 JR NZ,CreationDeZoneLibre
 LD A,L
 CP $FF
 JR NZ,CreationDeZoneLibre
;On modifie l'adresse du programme dans la VAT
 LD HL,(AdresseProgVAT-IONEMU+$8D26)
 LD (HL),DEBUT_PROG_1
 INC HL
 LD (HL),DEBUT_PROG_2
 CALL CREATE_TMP_IONEMU
 RET

RePlaceLeProg:

;initialisation
 SET 1,(IY+$0D)
 RES 3,(IY+$05)
 CALL DEL_TMP_IONEMU
 LD HL,(TailleProg)
 LD (TailleDonnesADeplacer),HL
 LD HL,DEBUT_PROG
 LD (AdresseProgDetruit),HL
 LD HL,(AdresseInitProg)
 LD BC,(TailleProg)
 ADD HL,BC
 LD (AdresseProgDeplace),HL

CreationDeZoneLibre_2:
;On crer une zone de mmoire  l'adresse AdresseProgDeplace de HL octets
;HL est { = 768 si TailleDonnesADeplacer>768
;         = TailleDonnesADeplacer sinon

 LD HL,(TailleDonnesADeplacer)
 LD BC,768
 SBC HL,BC
 JP P,TaillePositive_2-IONEMU+$8D26
 LD HL,(TailleDonnesADeplacer)
 JR TailleCalculee_2
TaillePositive_2:
 LD HL,768
TailleCalculee_2:
 PUSH HL
 LD DE,(TailleDonnesADeplacer)
 EX DE,HL
 SBC HL,DE
 LD (TailleDonnesADeplacer),HL
 POP HL
;On a calcul la taille de la mmoire  allouer
 PUSH HL
 LD DE,(AdresseProgDeplace)
 CALL _insertmem ;Allocates a region of memory: HL = size DE = address
;On copie maintenant les donnes vers la nouvelle adresse
 POP HL
 PUSH HL
 LD B,H
 LD C,L
 LD HL,(AdresseProgDetruit)
 LD DE,(AdresseProgDeplace)
 LDIR
 POP HL
;On detruit la zone copie du programme
 EX DE,HL
 PUSH DE
 LD HL,(AdresseProgDetruit)
 CALL _deletemem    ;Deletes a region of allocated memory: HL = address DE = size
 POP DE
;On regarde s'il reste des donnes  copier
 LD HL,(TailleDonnesADeplacer)
 LD A,H
 CP $FF
 JR NZ,CreationDeZoneLibre_2
 LD A,L
 CP $FF
 JR NZ,CreationDeZoneLibre_2
;On modifie l'adresse du programme dans la VAT
 LD HL,(AdresseProgVAT-IONEMU+$8D26)
 LD A,(AdresseInitProg+1)
 LD (HL),A
 INC HL
 LD A,(AdresseInitProg)
 LD (HL),A
 CALL CREATE_TMP_IONEMU
 RET

AdresseION83EMUDansRam .DW 0
AdresseProgALancer .DW 0
AdresseProgVAT .DW 0
AdresseInitProg2       .DW 0
TailleDonnesADeplacer2 .DW 0
TailleProg2            .DW 0
AdresseProgDetruit2    .DW 0
AdresseProgDeplace2    .DW 0

AdresseInitProg       = AdresseInitProg2      -IONEMU+$8D26
TailleDonnesADeplacer = TailleDonnesADeplacer2-IONEMU+$8D26
TailleProg            = TailleProg2           -IONEMU+$8D26
AdresseProgDetruit    = AdresseProgDetruit2   -IONEMU+$8D26
AdresseProgDeplace    = AdresseProgDeplace2   -IONEMU+$8D26

PetitCode2:
 LD HL,(AdresseION83EMUDansRam-IONEMU+$8D26)
 LD DE,IONEMU-Commentaire+41
 ADD HL,DE
;HL->IONEMU
 LD DE,$8D26
 LD BC,TailleIONEMU
EchangeDonnees2:
 PUSH BC
 LD A,(DE)
 LD C,(HL)
 EX DE,HL
 LD (DE),A
 LD (HL),C
 EX DE,HL
 INC DE
 INC HL
 POP BC
 DEC BC
 XOR A
 CP B
 JR NZ,EchangeDonnees2
 CP C
 JR NZ,EchangeDonnees2
 RET

PetitCode2Fin:

PetitCode2Taille = PetitCode2Fin-PetitCode2

IONEMUFin:





























TailleIONEMU = IONEMUFin-IONEMU

 .echo "Il reste "
 .echo DEBUT_PROG-$8D26-TailleIONEMU
 .echo " octets libres dans TailleIONEMU.\n"









